#!/usr/bin/env bash

# a batch found on the web building a library, 

# // this program is part of my 'deco-Math' project,
# // issue_I0005a_weak_powers_of_ten
# 
# // Copyright (c) 2021 ... Bernhard Samtleben, Hamburg, Germany.
# 
# // this program / collection is provided in hope it can be useful,.
# // but WITHOUT ANY WARRANTY, to the extent permitted by law, without
# // even the implied warranty of MERCHANTABILITY or FITNESS FOR ANY.
# // OR A PARTICULAR PURPOSE.
# // !!! --- CHECK BEFORE USE, USE AT YOUR OWN RISK --- !!!
# 
# // this program is free software, private use or use in free software 
# // acc. Apache or GNU Licenses is free, 
# // use in profit oriented businesses requires agreeing about a fee 
# // with the author in advance. 
# 
# // further info: see README

mkdir -p build
pushd build

clang++ \
    -c \
    -Wall \
    -o libpowers10l.o \
    -I ../include \
    ../src/libpowers10l.cpp && \

llvm-ar \
    rc ../lib/libpowers10l.a \
    libpowers10l.o

popd

# try to understand the differences between icpx and icx producing clean (ispx) and deviating (icx) powers of ten for long doubles ... 
# options with which compiler and linker an invoked, only the differences, 

# 10,11c10
# icpx: < clang++: warning: treating 'c' input as 'c++' when in C++ mode, this behavior is deprecated [-Wdeprecated]
# icpx: <  "/opt/intel/oneapi/compiler/2021.4.0/linux/bin/clang++" -cc1 -triple x86_64-unknown-linux-gnu -emit-obj --mrelax-relocations -disable-free -disable-llvm-verifier -discard-value-names -main-file-name mw_powers_10_t1_long.c -mrelocation-model static -fveclib=SVML -mframe-pointer=none -menable-no-infs -menable-no-nans -menable-unsafe-fp-math -fno-signed-zeros -mreassociate -freciprocal-math -fdenormal-fp-math=preserve-sign,preserve-sign -ffp-contract=fast -fno-rounding-math -ffast-math -ffinite-math-only -mconstructor-aliases -munwind-tables -target-cpu x86-64 -mllvm -x86-enable-unaligned-vector-move=true -tune-cpu generic -debugger-tuning=gdb -v -fcoverage-compilation-dir=/root/fritz_x/hdv/bs/deco-math/deco-math_issue_I0005_failing_roundings_E_C_G/clean_powers_of_ten/pow_10_y_vs_1Ey -resource-dir /opt/intel/oneapi/compiler/2021.4.0/linux/lib/clang/13.0.0 -I/opt/intel/oneapi/vpl/2021.6.0/include -I/opt/intel/oneapi/tbb/2021.4.0/env/../include -I/opt/intel/oneapi/mpi/2021.4.0//include -I/opt/intel/oneapi/mkl/2021.4.0/include -I/opt/intel/oneapi/ipp/2021.4.0/include -I/opt/intel/oneapi/ippcp/2021.4.0/include -I/opt/intel/oneapi/ipp/2021.4.0/include -I/opt/intel/oneapi/dpl/2021.5.0/linux/include -I/opt/intel/oneapi/dpcpp-ct/2021.4.0/include -I/opt/intel/oneapi/dnnl/2021.4.0/cpu_dpcpp_gpu_dpcpp/lib -I/opt/intel/oneapi/dev-utilities/2021.4.0/include -I/opt/intel/oneapi/dal/2021.4.0/include -I/opt/intel/oneapi/compiler/2021.4.0/linux/include -I/opt/intel/oneapi/ccl/2021.4.0/include/cpu_gpu_dpcpp -internal-isystem /opt/intel/oneapi/compiler/2021.4.0/linux/bin/../compiler/include -internal-isystem /usr/lib/gcc/x86_64-linux-gnu/10/../../../../include/c++/10                                                                    -internal-isystem /usr/lib/gcc/x86_64-linux-gnu/10/../../../../include/x86_64-linux-gnu/c++/10 -internal-isystem /usr/lib/gcc/x86_64-linux-gnu/10/../../../../include/c++/10/backward -internal-isystem /opt/intel/oneapi/compiler/2021.4.0/linux/lib/clang/13.0.0/include -internal-isystem /usr/local/include -internal-isystem /usr/lib/gcc/x86_64-linux-gnu/10/../../../../x86_64-linux-gnu/include -internal-externc-isystem /usr/include/x86_64-linux-gnu -internal-externc-isystem /include -internal-externc-isystem /usr/include -O2 -fdeprecated-macro -fdebug-compilation-dir=/root/fritz_x/hdv/bs/deco-math/deco-math_issue_I0005_failing_roundings_E_C_G/clean_powers_of_ten/pow_10_y_vs_1Ey -ferror-limit 19 -fheinous-gnu-extensions -fgnuc-version=4.2.1 -fcxx-exceptions -fexceptions -fcolor-diagnostics -vectorize-loops -vectorize-slp -D__GCC_HAVE_DWARF2_CFI_ASM=1 -fintel-compatibility -mllvm -disable-hir-generate-mkl-call -mllvm -intel-libirc-allowed -mllvm -loopopt=0 -mllvm -enable-lv -o /tmp/mw_powers_10_t1_long-15db6f.o -x c++ mw_powers_10_t1_long.c
# icx:  >  "/opt/intel/oneapi/compiler/2021.4.0/linux/bin/clang"   -cc1 -triple x86_64-unknown-linux-gnu -emit-obj --mrelax-relocations -disable-free -disable-llvm-verifier -discard-value-names -main-file-name mw_powers_10_t1_long.c -mrelocation-model static -fveclib=SVML -mframe-pointer=none -menable-no-infs -menable-no-nans -menable-unsafe-fp-math -fno-signed-zeros -mreassociate -freciprocal-math -fdenormal-fp-math=preserve-sign,preserve-sign -ffp-contract=fast -fno-rounding-math -ffast-math -ffinite-math-only -mconstructor-aliases -munwind-tables -target-cpu x86-64 -mllvm -x86-enable-unaligned-vector-move=true -tune-cpu generic -debugger-tuning=gdb -v -fcoverage-compilation-dir=/root/fritz_x/hdv/bs/deco-math/deco-math_issue_I0005_failing_roundings_E_C_G/clean_powers_of_ten/pow_10_y_vs_1Ey -resource-dir /opt/intel/oneapi/compiler/2021.4.0/linux/lib/clang/13.0.0 -I/opt/intel/oneapi/vpl/2021.6.0/include -I/opt/intel/oneapi/tbb/2021.4.0/env/../include -I/opt/intel/oneapi/mpi/2021.4.0//include -I/opt/intel/oneapi/mkl/2021.4.0/include -I/opt/intel/oneapi/ipp/2021.4.0/include -I/opt/intel/oneapi/ippcp/2021.4.0/include -I/opt/intel/oneapi/ipp/2021.4.0/include -I/opt/intel/oneapi/dpl/2021.5.0/linux/include -I/opt/intel/oneapi/dpcpp-ct/2021.4.0/include -I/opt/intel/oneapi/dnnl/2021.4.0/cpu_dpcpp_gpu_dpcpp/lib -I/opt/intel/oneapi/dev-utilities/2021.4.0/include -I/opt/intel/oneapi/dal/2021.4.0/include -I/opt/intel/oneapi/compiler/2021.4.0/linux/include -I/opt/intel/oneapi/ccl/2021.4.0/include/cpu_gpu_dpcpp -internal-isystem /opt/intel/oneapi/compiler/2021.4.0/linux/bin/../compiler/include -internal-isystem                                                             /opt/intel/oneapi/compiler/2021.4.0/linux/lib/clang/13.0.0/include                                                                                                                                                                                                                                                                            -internal-isystem /usr/local/include -internal-isystem /usr/lib/gcc/x86_64-linux-gnu/10/../../../../x86_64-linux-gnu/include -internal-externc-isystem /usr/include/x86_64-linux-gnu -internal-externc-isystem /include -internal-externc-isystem /usr/include -O2                    -fdebug-compilation-dir=/root/fritz_x/hdv/bs/deco-math/deco-math_issue_I0005_failing_roundings_E_C_G/clean_powers_of_ten/pow_10_y_vs_1Ey -ferror-limit 19 -fheinous-gnu-extensions -fgnuc-version=4.2.1                               -fcolor-diagnostics -vectorize-loops -vectorize-slp -D__GCC_HAVE_DWARF2_CFI_ASM=1 -fintel-compatibility -mllvm -disable-hir-generate-mkl-call -mllvm -intel-libirc-allowed -mllvm -loopopt=0 -mllvm -enable-lv -o /tmp/mw_powers_10_t1_long-14fb5d.o -x c   mw_powers_10_t1_long.c

# 32,34d30
# icpx: ->                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            <  /usr/lib/gcc/x86_64-linux-gnu/10/../../../../include/c++/10
# icpx: ->                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             <  /usr/lib/gcc/x86_64-linux-gnu/10/../../../../include/x86_64-linux-gnu/c++/10
# icpx: ->                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            <  /usr/lib/gcc/x86_64-linux-gnu/10/../../../../include/c++/10/backward
# 40c36,40
# icpx: <  "/usr/bin/ld" --eh-frame-hdr -m elf_x86_64 -dynamic-linker /lib64/ld-linux-x86-64.so.2 -o mw_powers_10_t1_long /lib/x86_64-linux-gnu/crt1.o /lib/x86_64-linux-gnu/crti.o /usr/lib/gcc/x86_64-linux-gnu/10/crtbegin.o -L/opt/intel/oneapi/compiler/2021.4.0/linux/bin/../compiler/lib/intel64_lin -L/opt/intel/oneapi/compiler/2021.4.0/linux/bin/../lib -L/opt/intel/oneapi/compiler/2021.4.0/linux/bin/../compiler/lib/intel64_lin -L/usr/lib/gcc/x86_64-linux-gnu/10 -L/usr/lib/gcc/x86_64-linux-gnu/10/../../../../lib64 -L/lib/x86_64-linux-gnu -L/lib/../lib64 -L/usr/lib/x86_64-linux-gnu -L/usr/lib/../lib64 -L/usr/lib/gcc/x86_64-linux-gnu/10/../../.. -L/opt/intel/oneapi/compiler/2021.4.0/linux/bin/../lib -L/lib -L/usr/lib -L/opt/intel/oneapi/vpl/2021.6.0/lib -L/opt/intel/oneapi/tbb/2021.4.0/env/../lib/intel64/gcc4.8 -L/opt/intel/oneapi/mpi/2021.4.0//libfabric/lib -L/opt/intel/oneapi/mpi/2021.4.0//lib/release -L/opt/intel/oneapi/mpi/2021.4.0//lib -L/opt/intel/oneapi/mkl/2021.4.0/lib/intel64 -L/opt/intel/oneapi/ipp/2021.4.0/lib/intel64 -L/opt/intel/oneapi/ippcp/2021.4.0/lib/intel64 -L/opt/intel/oneapi/ipp/2021.4.0/lib/intel64 -L/opt/intel/oneapi/dnnl/2021.4.0/cpu_dpcpp_gpu_dpcpp/lib -L/opt/intel/oneapi/dal/2021.4.0/lib/intel64 -L/opt/intel/oneapi/compiler/2021.4.0/linux/compiler/lib/intel64_lin -L/opt/intel/oneapi/compiler/2021.4.0/linux/lib -L/opt/intel/oneapi/ccl/2021.4.0/lib/cpu_gpu_dpcpp /tmp/mw_powers_10_t1_long-15db6f.o -Bstatic -lsvml -Bdynamic -Bstatic -lirng -Bdynamic -lstdc++ -Bstatic -limf -Bdynamic -lm -lgcc_s -lgcc                                    -Bstatic -lirc -Bdynamic -ldl -lgcc_s -lgcc             -lc -lgcc_s                    -lgcc                                    -Bstatic -lirc_s -Bdynamic /usr/lib/gcc/x86_64-linux-gnu/10/crtend.o /lib/x86_64-linux-gnu/crtn.o
# icx:  >  "/usr/bin/ld" --eh-frame-hdr -m elf_x86_64 -dynamic-linker /lib64/ld-linux-x86-64.so.2 -o mw_powers_10_t1_long /lib/x86_64-linux-gnu/crt1.o /lib/x86_64-linux-gnu/crti.o /usr/lib/gcc/x86_64-linux-gnu/10/crtbegin.o -L/opt/intel/oneapi/compiler/2021.4.0/linux/bin/../compiler/lib/intel64_lin -L/opt/intel/oneapi/compiler/2021.4.0/linux/bin/../lib -L/opt/intel/oneapi/compiler/2021.4.0/linux/bin/../compiler/lib/intel64_lin -L/usr/lib/gcc/x86_64-linux-gnu/10 -L/usr/lib/gcc/x86_64-linux-gnu/10/../../../../lib64 -L/lib/x86_64-linux-gnu -L/lib/../lib64 -L/usr/lib/x86_64-linux-gnu -L/usr/lib/../lib64 -L/usr/lib/gcc/x86_64-linux-gnu/10/../../.. -L/opt/intel/oneapi/compiler/2021.4.0/linux/bin/../lib -L/lib -L/usr/lib -L/opt/intel/oneapi/vpl/2021.6.0/lib -L/opt/intel/oneapi/tbb/2021.4.0/env/../lib/intel64/gcc4.8 -L/opt/intel/oneapi/mpi/2021.4.0//libfabric/lib -L/opt/intel/oneapi/mpi/2021.4.0//lib/release -L/opt/intel/oneapi/mpi/2021.4.0//lib -L/opt/intel/oneapi/mkl/2021.4.0/lib/intel64 -L/opt/intel/oneapi/ipp/2021.4.0/lib/intel64 -L/opt/intel/oneapi/ippcp/2021.4.0/lib/intel64 -L/opt/intel/oneapi/ipp/2021.4.0/lib/intel64 -L/opt/intel/oneapi/dnnl/2021.4.0/cpu_dpcpp_gpu_dpcpp/lib -L/opt/intel/oneapi/dal/2021.4.0/lib/intel64 -L/opt/intel/oneapi/compiler/2021.4.0/linux/compiler/lib/intel64_lin -L/opt/intel/oneapi/compiler/2021.4.0/linux/lib -L/opt/intel/oneapi/ccl/2021.4.0/lib/cpu_gpu_dpcpp /tmp/mw_powers_10_t1_long-14fb5d.o -Bstatic -lsvml -Bdynamic -Bstatic -lirng -Bdynamic          -Bstatic -limf -Bdynamic -lm         -lgcc --as-needed -lgcc_s --no-as-needed -Bstatic -lirc -Bdynamic -ldl         -lgcc --as-needed     -lgcc_s --no-as-needed -lc -lgcc --as-needed -lgcc_s --no-as-needed -Bstatic -lirc_s -Bdynamic /usr/lib/gcc/x86_64-linux-gnu/10/crtend.o /lib/x86_64-linux-gnu/crtn.o


# ---
# > mw_powers_10_t1_long.c:134:7: warning: implicit declaration of function 'exp10l' is invalid in C99 [-Wimplicit-function-declaration]
# >                 a = exp10l( i );                // pow, other function, this 'clean' with icpx, 
# >                     ^
# > 1 warning generated.
# "/opt/intel/oneapi/compiler/2021.4.0/linux/bin/clang++" 
# # clang++ -cc1 -triple x86_64-unknown-linux-gnu -emit-obj   \
# # -fcoverage-compilation-dir=.  \
# #    \
# # -internal-isystem /opt/intel/oneapi/compiler/2021.4.0/linux/bin/../compiler/include -internal-isystem /usr/lib/gcc/x86_64-linux-gnu/10/../../../../include/c++/10 -internal-isystem /usr/lib/gcc/x86_64-linux-gnu/10/../../../../include/x86_64-linux-gnu/c++/10 -internal-isystem /usr/lib/gcc/x86_64-linux-gnu/10/../../../../include/c++/10/backward -internal-isystem /opt/intel/oneapi/compiler/2021.4.0/linux/lib/clang/13.0.0/include -internal-isystem /usr/local/include -internal-isystem /usr/lib/gcc/x86_64-linux-gnu/10/../../../../x86_64-linux-gnu/include -internal-externc-isystem /usr/include/x86_64-linux-gnu -internal-externc-isystem /include -internal-externc-isystem /usr/include   \
# #    \
# #    \
# # -o mw_powers_10_t1_long.tmp_obj -x c++ mw_powers_10_t1_long.c

#  "/usr/bin/ld" 
# # ld --eh-frame-hdr -m elf_x86_64 -dynamic-linker /lib64/ld-linux-x86-64.so.2 -o mw_powers_10_t1_long /lib/x86_64-linux-gnu/crt1.o /lib/x86_64-linux-gnu/crti.o /usr/lib/gcc/x86_64-linux-gnu/10/crtbegin.o \
# # -L/opt/intel/oneapi/compiler/2021.4.0/linux/bin/../compiler/lib/intel64_lin -L/opt/intel/oneapi/compiler/2021.4.0/linux/bin/../lib -L/opt/intel/oneapi/compiler/2021.4.0/linux/bin/../compiler/lib/intel64_lin -L/usr/lib/gcc/x86_64-linux-gnu/10 -L/usr/lib/gcc/x86_64-linux-gnu/10/../../../../lib64 -L/lib/x86_64-linux-gnu -L/lib/../lib64 -L/usr/lib/x86_64-linux-gnu -L/usr/lib/../lib64 -L/usr/lib/gcc/x86_64-linux-gnu/10/../../.. -L/opt/intel/oneapi/compiler/2021.4.0/linux/bin/../lib -L/lib -L/usr/lib -L/opt/intel/oneapi/vpl/2021.6.0/lib -L/opt/intel/oneapi/tbb/2021.4.0/env/../lib/intel64/gcc4.8 -L/opt/intel/oneapi/mpi/2021.4.0//libfabric/lib -L/opt/intel/oneapi/mpi/2021.4.0//lib/release -L/opt/intel/oneapi/mpi/2021.4.0//lib -L/opt/intel/oneapi/mkl/2021.4.0/lib/intel64 -L/opt/intel/oneapi/ipp/2021.4.0/lib/intel64 -L/opt/intel/oneapi/ippcp/2021.4.0/lib/intel64 -L/opt/intel/oneapi/ipp/2021.4.0/lib/intel64 -L/opt/intel/oneapi/dnnl/2021.4.0/cpu_dpcpp_gpu_dpcpp/lib -L/opt/intel/oneapi/dal/2021.4.0/lib/intel64 -L/opt/intel/oneapi/compiler/2021.4.0/linux/compiler/lib/intel64_lin -L/opt/intel/oneapi/compiler/2021.4.0/linux/lib -L/opt/intel/oneapi/ccl/2021.4.0/lib/cpu_gpu_dpcpp \
# # mw_powers_10_t1_long.tmp_obj -Bstatic -limf -Bdynamic -lm -Bstatic -lsvml -Bdynamic -Bstatic -lirng -Bdynamic -lstdc++ -Bstatic -limf -Bdynamic -lm -lgcc_s -lgcc -Bstatic -lirc -Bdynamic -ldl -lgcc_s -lgcc -lc -lgcc_s -lgcc -Bstatic -lirc_s -Bdynamic /usr/lib/gcc/x86_64-linux-gnu/10/crtend.o /lib/x86_64-linux-gnu/crtn.o

# --mrelax-relocations -disable-free -disable-llvm-verifier -discard-value-names -main-file-name mw_powers_10_t1_long.c -mrelocation-model static -fveclib=SVML -mframe-pointer=none -menable-no-infs -menable-no-nans -menable-unsafe-fp-math -fno-signed-zeros -mreassociate -freciprocal-math -fdenormal-fp-math=preserve-sign,preserve-sign -ffp-contract=fast -fno-rounding-math -ffast-math -ffinite-math-only -mconstructor-aliases -munwind-tables -target-cpu x86-64 -mllvm -x86-enable-unaligned-vector-move=true -tune-cpu generic -debugger-tuning=gdb -v 
# -fcoverage-compilation-dir=/root/fritz_x/hdv/bs/deco-math/deco-math_issue_I0005_failing_roundings_E_C_G/clean_powers_of_ten/pow_10_y_vs_1Ey -resource-dir /opt/intel/oneapi/compiler/2021.4.0/linux/lib/clang/13.0.0 \
# -I/opt/intel/oneapi/vpl/2021.6.0/include -I/opt/intel/oneapi/tbb/2021.4.0/env/../include -I/opt/intel/oneapi/mpi/2021.4.0//include -I/opt/intel/oneapi/mkl/2021.4.0/include -I/opt/intel/oneapi/ipp/2021.4.0/include -I/opt/intel/oneapi/ippcp/2021.4.0/include -I/opt/intel/oneapi/ipp/2021.4.0/include -I/opt/intel/oneapi/dpl/2021.5.0/linux/include -I/opt/intel/oneapi/dpcpp-ct/2021.4.0/include -I/opt/intel/oneapi/dnnl/2021.4.0/cpu_dpcpp_gpu_dpcpp/lib -I/opt/intel/oneapi/dev-utilities/2021.4.0/include -I/opt/intel/oneapi/dal/2021.4.0/include -I/opt/intel/oneapi/compiler/2021.4.0/linux/include -I/opt/intel/oneapi/ccl/2021.4.0/include/cpu_gpu_dpcpp \
#  
# -O2 -fdeprecated-macro -fdebug-compilation-dir=/root/fritz_x/hdv/bs/deco-math/deco-math_issue_I0005_failing_roundings_E_C_G/clean_powers_of_ten/pow_10_y_vs_1Ey \
# -ferror-limit 19 -fheinous-gnu-extensions -fgnuc-version=4.2.1 -fcxx-exceptions -fexceptions -fcolor-diagnostics -vectorize-loops -vectorize-slp -D__GCC_HAVE_DWARF2_CFI_ASM=1 -fintel-compatibility -mllvm -disable-hir-generate-mkl-call -mllvm -intel-libirc-allowed -mllvm -loopopt=0 -mllvm -enable-lv \
