

/*---------------------------------------------------*/
/* Check different calculations for powers of ten    */
/* e.g. mostly 'POW( 10, x )' != '1Ex' != '=10^x'    */
/* depending on compiler and options.                */
/*---------------------------------------------------*/

// this program is part of my 'deco-Math' project.
// issue_I0005a_weak_powers_of_ten

// - WIP! -, striving for DEcimal COrrect calculations.
// (also with FP numbers acc. IEEE 754).

// Copyright (c) 2021 ... Bernhard Samtleben, Hamburg, Germany.
// all rights reserved, for the moment company secret..

// contact: see README


#include <iostream>
#include <iomanip>		// reg. std::setprecision, 
#include <math.h> 		// reg. power, exp10, ...,
#include "libpowers10l.h"

int main( void )
{
//	mynamespace::helloWorld();
	helloWorld();
	int error_count = 0; 
//	for( int i = -4952; i < 4933; i++)	// full range, 
 	for( int i =  -10; i <  11; i++) 	// reduced range, 
	{
//		long double a = mynamespace::power10l( i );
		long double a = power10l( i );
		if ( a != powl( 10, i ) ) 
		{
			std::cout << std::scientific << std::setprecision( 25 ) << "power10l( " << i << " ) per 'exp10l'= " << a << std::endl;
			std::cout << std::scientific << std::setprecision( 25 ) << "power10l( " << i << " ) per 'powl()'= " << powl( 10, i ) << std::endl << std::endl;
			error_count++;
		}
	}
	std::cout << std::fixed << std::setprecision( 0 ) << "error_count = " << error_count << std::endl;
	printf( "error_count = %d\n ", error_count );
	return(0);
}